L'objectif de ce premier tp est de prendre en main Logisim Evolution, un logiciel libre qui permet de dessiner, simuler et analyser des circuits simples construits à partir de portes logiques.


[[_TOC_]]

# Un premier circuit

Ajoutez un circuit au fichier ouvert par défaut (soit par Projet → Ajouter un circuit, soit à l'aide de la croix verte) que vous nommez `exercice1`.
L'équation de ce circuit est $`s = a.b + \bar{a}.b`$.

Une fois le circuit dessiné, utiliser les différentes fonctions de Logisim Evolution pour le valider :
  - simulez le circuit en changeant les valeurs des entrées (utilisez l'outil `main` disponible dans la barre d'outils) 
  - vérifiez la table de vérité du circuit et son équation (Projet → Analyser le circuit)

Une fois que c'est fait, pensez à sauver le fichier.

# Décodeur 

Un décodeur est un circuits ayant $`k`$ entrées de largeur 1 bits $`i_0`$ à $`i_{k-1}`$ et $`n`$ sorties de largeur 1 bits $`s_0`$ à $`s_{n-1}`$.
Les entrées codent en binaire un nombre $`x`$ sur $`k`$ bits : 
```math
x = \sum_{j=0}^{k-1} i_j \times 2^j 
```
Le circuit décodeur met à $`1`$ la sortie $`x`$  et toutes les autres à 0.

  1. Si un circuit décodeur possède 3 entrées, combien de sortie doit-il avoir ?
  2. Donnez la table de vérité de ce circuit.
  3. Créez un nouveau circuit dans votre fichier et dessinez un circuit décodeur à 3 entrées. Validez le, puis pensez à sauver votre fichier.

# Réutiliser un circuit

Maintenant que vous disposez d'un décodeur, il est possible de l'utiliser dans un autre circuit. Pour cela, créez un nouveau circuit dans votre fichier, puis faites glisser le décodeur sur l'espace de dessin des circuits.

Dans le dossier Entrée/Sortie, sélectionnez le composant `Afficheur 7 segments` et ajoutez le au circuit. 
Dans la configuration du composant, désactivez l'option `Affiche le point décimal`.

Construisez un circuit entre le décodeur et l'afficheur 7 segments de sorte que le nombre affiché corresponde au codage binaire en entrée du décodeur.

# Comparateur

Construisez un circuit possédant 2 entrées $`a`$  et $`b`$, et trois sorties : 
  - $`eg`$, qui est à 1 si et seulement si $`a = b`$ ;
  - $`sup`$ , qui est à 1 si et seulement si $`a > b`$ ;
  - et $`inf`$, qui est à 1 si et seulement si $`a < b`$.

# Comparateur 4 bits

Construisez un circuit permettant de comparer deux nombres binaires codés sur 4 bits.


