
# Partie 1 : addition avec propagation de la retenue

## Du demi-additionneur à l'additionneur

  1. Soient $`a`$ et $`b`$ deux nombres sur 1 bit. Quels sont les résultats possibles de l'addition $`a+b`$ ?
  2. On souhaite construire un circuit pour l'addition de deux nombres sur 1 bit. Identifiez les entrées et les sorties, donnez la table de vérité, et dessinez le circuit.
  3. Supposons maintenant que l'on souhaite utiliser ce circuit pour construire un additionneur 2 bits. Quel problème se pose ? Revisitez la question précédente pour corriger ce problème. Cela nécessite d'ajouter une nouvelle entrée, que vous appelerez $`c`$ pour carry (retenue en anglais)

## Additionneur 4 bits avec propagation de la retenue

  1. Utilisez votre circuit additionneur 1 bit pour construire un circuit additionneur 4 bits. Simulez votre circuit pour vérifier son bon fonctionnement.
  2. Comme on l'a dit en cours, il existe une relation entre la fréquence de fonctionnement d'un système et la « longueur » du chemin le plus long (on parle de chemin critique) à traverser dans un circuit entre deux tics d'horloge. Identifiez le chemin critique de votre circuit, et calculez sa longueur. Pour mesurer cette longueur, vous utiliserez comme unité le nombre de porte logique traversée. C'est bien sûr une approximation, car en réalité, toutes les portes ne sont pas « équivalentes ».
  3. Supposons que l'on veuille construire sur le même principe un additionneur $`n`$ bit. Quelle serait la longueur du chemin critique. Que pouvez-vous en déduire sur la capacité de passage à l'échelle de ce circuit ?

